
# About this Project

This project is being developed as a practical part of bachelor's thesis at Brno Universtiy of Technology - Faculty of Information Studies. It is as of now a work in progress, no results guaranteed.

The topic of this thesis is Generating a 3D Fingerprint Model. This application can be used to apply series of image processing filters to a fingerprint image to make it more suitable for conversion to 3D stl model and printing.
It should also have the functionality to convert the image to stl model.


# Prerequisites

For now this is only viable for ubuntu gnu/linux machines
Before cloning repository, you need these to succesfully use the application.

* python version 3.10 is a requirement might work on earlier python 3 versions
    ```sh
        apt install python3.10
    ```
* python graphical modules
    ```sh
        pip install numpy matplotlib opencv-python pillow
    ```


# Installation

Installation is relatively fast and easy.

1. Clone the repository
    ```sh
        git clone https://strade.fit.vutbr.cz/git/xlanro00/BP_DP-xlanro00
    ```
2. Prepare the image file with fingerprint, run the application


# Usage

There are two ways to enter filter series

* manually from command line
    ```sh
        python src/main.py res/test_fp.png res/test_fp_cpy.png 100 blur
    ```
* manually from preset saved in a json config file, that can be used to create new presets 
    ```sh
        python src/main.py res/test_fp.png res/test_fp_cpy.png 100 --config config/config.json default_preset
    ```
# Resulting images
Before filtering           |  After filtering
:-------------------------:|:-------------------------:
![before filtering](https://strade.fit.vutbr.cz/git/xlanro00/BP_DP-xlanro00/src/branch/master/res/example-before.png)  |  
![after filtering](https://strade.fit.vutbr.cz/git/xlanro00/BP_DP-xlanro00/src/branch/master/res/example-after.png)



# Roadmap

- [x] Load and store image
- [x] Apply basic image processing filters
- [ ] Create filter library with more filters
- [x] Use presets from config files
- [ ] Make it a viable option to process an image
- [ ] Convert image to stl format
- [ ] Export final model ready for printing


#
### Author

Rostislav Lán - xlanro00@stud.fit.vutbr.cz

### Supervisor

Ing. Petr Malaník

### Links

Project Link: [https://strade.fit.vutbr.cz/git/xlanro00/BP_DP-xlanro00](https://strade.fit.vutbr.cz/git/xlanro00/BP_DP-xlanro00)
